#include "Juego.h"
#include "GeneradorAleatorios.h"
#include "GestorRanking.h"
#include "Interfaz.h"
#include <iostream>
#include <string>
#include <sstream>

using namespace std;

Juego::Juego()
{
	list<Puntuacion> ranking;
	GestorRanking::getRanking(ranking);
}

void Juego::empezar()
{
	GeneradorAleatorios::init();

	while(Interfaz::getAccion()!=-1)
	{
		Interfaz::mostrarYElegir();

		if (Interfaz::getAccion()==1)
		{
			cout <<"3\a"<<endl;
			sleep(1);
			cout <<"2\a"<<endl;
			sleep(1);
			cout <<"1\a"<<endl;
			sleep(1);
			cout <<"¡YA!"<<endl;
			jugar(Interfaz::getMinutos());

		}
	}	
}

void Juego::jugar(int minutos)
{
	int segundos = minutos * 60;
	int n1,n2,operacion;
	
	gettimeofday(&start, 0);
	gettimeofday(&end, 0);

	factorDificultad=1;
	puntuacion=0;
	
	while((end.tv_sec - start.tv_sec)<segundos)
	{
		if (Interfaz::getSiTiempo())
			mostrarTiempo(segundos - (end.tv_sec - start.tv_sec));

		mostrarOperacion(n1,n2,operacion);

		if (comprobarResultado(n1,n2,operacion) && ((end.tv_sec - start.tv_sec)<segundos))
		{
			cout <<"¡Muy bien!"<<endl;
			puntuacion+=factorDificultad;
			factorDificultad+=1;
		}
		else if (!((end.tv_sec - start.tv_sec)<segundos))
		{
			cout <<"\aFuera de tiempo..."<<endl;
		}
		else
		{
			cout <<"\aFallaste..."<<endl;
			factorDificultad-=1;
			if (factorDificultad<1)
				factorDificultad = 1;
		}

		gettimeofday(&end, 0);
	}

	puntuacion = puntuacion / minutos;

	cout <<endl<<"Has conseguido una puntuación de: "<<puntuacion<<endl;
	cout <<"Tu edad mental es "<<calcularEdad(puntuacion)<<" años"<<endl;

	list<Puntuacion> ranking;
	list<Puntuacion>::iterator it;
	GestorRanking::getRanking(ranking);
	it=ranking.end();
	it--;	

	if (puntuacion>(*it).puntos)
	{	

		cout <<"¡Has entrado en el ranking! Introduce tu nombre: ";

		Puntuacion p;

		string input="";
		getline(cin,input);
		stringstream myStream(input);
		if (myStream >> input)
		{
			if (input=="")
			{
				input="anonimo";
			}
			else
			{
				if (input.length()>10)	
					input = input.substr(0,10);
			}
		}
		else
		{
			input="anonimo";
		}

		p.nombre=input;
		p.puntos=puntuacion;

		GestorRanking::setRanking(ranking,p);
	}
	else
	{
		cout <<"No has entrado en el ranking, más suerte la próxima vez"<<endl;
	}
}

void Juego::mostrarOperacion(int &n1, int &n2, int &operacion)
{
	operacion = GeneradorAleatorios::getInt(1,3);
	if (operacion==1)
	{
		n1 = GeneradorAleatorios::getInt(1, 5+factorDificultad);
		n2 = GeneradorAleatorios::getInt(1, 5+factorDificultad);
	}
	else if (operacion==2)
	{
		n1 = GeneradorAleatorios::getInt(factorDificultad, 5+factorDificultad);
		n2 = GeneradorAleatorios::getInt(1, n1);
	}	
	else if (operacion==3)
	{
		n1 = GeneradorAleatorios::getInt(1, 5+factorDificultad/3);
		n2 = GeneradorAleatorios::getInt(1, 5+factorDificultad/3);
	}

	cout <<n1<<" ";
	if (operacion==1)
	{
		cout <<"+ ";
	}
	else if (operacion==2)
	{
		cout <<"- ";
	}
	else if (operacion==3)
	{
		cout <<"* ";
	}
	cout <<n2<<" = ";
}

void Juego::mostrarTiempo(int segundos)
{
	cout <<"0"<<segundos/60<<":";
	
	if (segundos%60>9)
		cout<<segundos%60<<endl;
	else
		cout<<"0"<<segundos%60<<endl;
}

bool Juego::comprobarResultado(int n1, int n2, int operacion)
{
	int resultado;
	string input="";

	getline(cin,input);
	stringstream myStream(input);
	if (myStream >> resultado)
	{
		if (operacion==1)
		{
			gettimeofday(&end, 0);
			return resultado==n1+n2;
		}
		else if (operacion==2)
		{
			gettimeofday(&end, 0);
			return resultado==n1-n2;
		}
		else 
		{
			gettimeofday(&end, 0);
			return resultado==n1*n2;
		}
	}
	else
	{
		cout <<"ERROR, Debes introducir un numero"<<endl;
		gettimeofday(&end, 0);
		return false;
	}	
}

int Juego::calcularEdad(int puntuacion)
{
	float maxPuntuacion = 700;
	float minEdad=18;
	float maxEdad=100;
	
	int edad = ((minEdad-maxEdad)/maxPuntuacion)*puntuacion + 100;

	if (edad<18)	edad=18;
	else if (edad>100)	edad=100;

	return edad;
}
